# Requirements

List of debian (bullseye) package required.

 - `python3-ldap`
 - `python3-flask`
 - `uwsgi`
 - `uwsgi-plugin-python3`
 - `nginx`


# Configuration

 1. Copy all the files in `/opt/lilk-users`

 2. Edit LDAP settings in `lilik_users.py`

 3. Symlink `conf/uwsgi/lilik_users.ini` in `/etc/uwsgi/apps-enabled/`

        ln -s /opt/lilik-users/conf/uwsgi/lilik_users.ini /etc/uwsgi/apps-enabled/lilik_users.ini

 4. Configure nginx creating a `server` section in `/etc/nginx/sites-enabled/`


        # /etc/nginx/sites-enabled/site1.lilik.it.conf

        server {
            listen 443 ssl http2;
            listen [::]:443 ssl http2;

            # ... server_name and ssl configuration

            include /opt/lilik-users/conf/nginx/locations-lilik_users.conf;
        }

 5. Restart uwsgi and nginx

        systemctl restart uwsgi
        systemctl restart nginx

 6. Point your browser to `/add/add.html` and enjoy!
